# This file contains all the control parameters, hyperparameters, toggles, etc.
# needed to run the CCAO's automated valuation model

# Parameters in this file are associated with certain stages in the modeling
# pipeline. Changing a parameter means any pipeline stage associated with that
# parameter must be re-run. See dvc.yaml for parameter <-> stage associations
# and https://dvc.org/doc/command-reference/params for more information


# Run Control ------------------------------------------------------------------

# Note included with each run. Use this to summarize what changed about the run
# or add context
run_note: >
  Quick fix for buildings whose rates don't sum to 1

# Determines what stages and outputs are produced. See misc/file_dict.csv for
# details. Note, DVC does not support "conditional" stages, so changing this to
# anything other than "full" will require you to run each stage manually. See
# README for details
run_type: "full"

toggle:
  # Should the train stage run full cross-validation? Otherwise, the model
  # will be trained with the default hyperparameters specified below
  cv_enable: FALSE
  
  # Should SHAP values be calculated for this run in the interpret stage? Can be
  # desirable to save time when testing many models
  shap_enable: FALSE
  
  # Upload all modeling artifacts and results to S3 in the finalize stage. Set
  # to FALSE if you are not a CCAO employee
  upload_to_s3: TRUE


# Data/Ingest ------------------------------------------------------------------

# Assessment context and dates
assessment:
  # Year of assessment. Used to partition results and pull data
  year: "2023"
  
  # The statutorily "sale date" for the purpose of prediction
  date: "2023-01-01"
  
  # Added context for model artifacts stored in s3. Does not change behavior
  triad: "south"
  group: "condo"
  
  # Year from which property characteristics are pulled. Usually lags the
  # assessment year by 1
  data_year: "2022"
  
  # Temporary alternative year used to accomadate data issues between
  # 2023 iasWorld data and CCAO characteristics
  shift_year: "2023"

# Parameters used to define the input/training data
input:
  # The min and max years of sales to use for the training data sample
  min_sale_year: "2014"
  max_sale_year: "2022"
  
  # Time window (in months) used for rolling origin cross-validation and
  # calculating spatial lags i.e. lags are the average of the nearest K
  # properties for each N month window
  time_split: 15
  
  # Parameters used to trim the training data (sales) of outliers
  sale_validation:
  
    # Summary statistics grouping for detecting outlier sales i.e. an outlier
    # might be 3 standard deviations from the mean of township and class
    stat_groups: [
      "meta_year",
      "meta_township_code",
      "meta_class"
    ]
    
    # Predictor variables to use in the isolation forest classifier
    iso_forest: [
      "meta_sale_price",
      "sv_days_since_last_transaction",
      "sv_cgdr",
      "sv_sale_dup_counts"
    ]
    
    # Left and right boundaries (in standard deviations) used to trim the
    # training sample e.g. any sales more than 3 standard deviations from the
    # mean will be dropped
    dev_bounds: [2, 3]

  # Parameters used to construct condominium strata features
  strata:
    # Seed for k-means
    seed: 123
    
    # Grouping variables used in the construction of condo strata. Each group
    # will have its own independent strata of size K 1 and K 2 (see below)
    group_var: [
      "meta_township_code"
    ]
  
    # We can use either quantiles or k-means clustering to build condo strata
    type: "ntile"
    
    # Number of quantiles of centers to use when constructing strata
    k_1: 10
    k_2: 100
    
    # Max and min weights for mean sale price weighted by sale date i.e. the
    # the least recent sale counts half as much as the most recent one
    weight_min: 0.3
    weight_max: 1.0


# Cross-validation -------------------------------------------------------------

# Cross-validation parameters used in the train stage. Most are passed
# directly to tune_bayes()
cv:
  # Proportion of the training data to use for training vs test i.e. 0.9 means
  # the most recent 10% of sales are used as a test set
  split_prop: 0.9

  # Number of initial iterations to create before tuning. Recommend this number
  # be greater than the number of hyperparameters being tuned
  initial_set: 20
  
  # Maximum number of search iterations
  max_iterations: 70
  
  # Max number of search iterations without improvement before stopping search
  no_improve: 20
  
  # Metric used to select the "best" set of parameters from CV iterations. Must
  # be manually included the metric_set() passed to tune_bayes()
  best_metric: "rmse"


# Model (Hyper)parameters ------------------------------------------------------

# Static and tuneable parameters that define the structure and behavior of the
# model itself
model:
  engine: "lightgbm"
  
  # Objective/loss function minimized by LightGBM. See website for possible
  # options: https://lightgbm.readthedocs.io/en/latest/Parameters.html#objective
  objective: "rmse"

  # Parameters related to model determinism. Current settings should force 
  # the same output every time if the same hyperparameters are used
  seed: 2023
  deterministic: TRUE
  force_row_wise: TRUE
  
  # Model verbosity: < 0: Fatal, = 0: Error (Warning), = 1: Info, > 1: Debug
  verbose: -1

  predictor:
    # Vector of predictors from the training data included in the model. Edit
    # this list to add or remove variables from the model
    all: [
      "meta_township_code",
      "meta_nbhd_code",
      "meta_tieback_proration_rate",
      "char_yrblt",
      "char_land_sf",
      "char_building_units",
      "char_building_non_units",
      "char_bldg_is_mixed_use",
      "char_building_sf",
      "char_unit_sf",
      "char_bedrooms",
      "char_half_baths",
      "char_full_baths",
      "loc_longitude",
      "loc_latitude",
      "loc_cook_municipality_name",
      "loc_env_flood_fema_sfha",
      "loc_env_flood_fs_factor",
      "loc_env_flood_fs_risk_direction",
      "loc_env_airport_noise_dnl",
      "loc_school_elementary_district_geoid",
      "loc_school_secondary_district_geoid",
      "loc_access_cmap_walk_nta_score",
      "loc_access_cmap_walk_total_score",
      "prox_num_pin_in_half_mile",
      "prox_num_bus_stop_in_half_mile",
      "prox_num_foreclosure_per_1000_pin_past_5_years",
      "prox_num_school_in_half_mile",
      "prox_num_school_with_rating_in_half_mile",
      "prox_avg_school_rating_in_half_mile",
      "prox_nearest_bike_trail_dist_ft",
      "prox_nearest_cemetery_dist_ft",
      "prox_nearest_cta_route_dist_ft",
      "prox_nearest_cta_stop_dist_ft",
      "prox_nearest_hospital_dist_ft",
      "prox_lake_michigan_dist_ft",
      "prox_nearest_major_road_dist_ft",
      "prox_nearest_metra_route_dist_ft",
      "prox_nearest_metra_stop_dist_ft",
      "prox_nearest_park_dist_ft",
      "prox_nearest_railroad_dist_ft",
      "prox_nearest_water_dist_ft",
      "acs5_percent_age_children",
      "acs5_percent_age_senior",
      "acs5_median_age_total",
      "acs5_percent_mobility_no_move",
      "acs5_percent_mobility_moved_from_other_state",
      "acs5_percent_household_family_married",
      "acs5_percent_household_nonfamily_alone",
      "acs5_percent_education_high_school",
      "acs5_percent_education_bachelor",
      "acs5_percent_education_graduate",
      "acs5_percent_income_below_poverty_level",
      "acs5_median_income_household_past_year",
      "acs5_median_income_per_capita_past_year",
      "acs5_percent_income_household_received_snap_past_year",
      "acs5_percent_employment_unemployed",
      "acs5_median_household_total_occupied_year_built",
      "acs5_median_household_renter_occupied_gross_rent",
      "acs5_percent_household_owner_occupied",
      "acs5_percent_household_total_occupied_w_sel_cond",
      "acs5_percent_mobility_moved_in_county",
      "other_tax_bill_rate",
      "time_sale_year",
      "time_sale_day",
      "time_sale_quarter_of_year",
      "time_sale_month_of_year",
      "time_sale_day_of_year",
      "time_sale_day_of_month",
      "time_sale_day_of_week",
      "time_sale_post_covid",
      "meta_strata_1",
      "meta_strata_2"
    ]
    
    # List of predictors included in predictor.all which are categoricals. It is
    # CRITICAL that any categorical variables are included in this list, else
    # LightGBM will treat them as numeric
    categorical: [
      "meta_township_code",
      "meta_nbhd_code",
      "loc_cook_municipality_name",
      "loc_school_elementary_district_geoid",
      "loc_school_secondary_district_geoid",
      "time_sale_quarter_of_year",
      "meta_strata_1",
      "meta_strata_2"
    ]
    
    # List of variables used with the recipe step step_impute_knn(). The knn
    # variables will have missing values imputed, while the knn_imp variables
    # are used to do the imputing
    knn: [
      "meta_strata_1",
      "meta_strata_2"
    ]
    
    knn_imp: [
      "loc_latitude",
      "loc_longitude",
      "char_building_units",
      "char_yrblt"
    ]
    
    # List of identifiers for each observation, can be ignored
    id: [
      "meta_year",
      "meta_pin",
      "meta_class",
      "meta_card_num",
      "meta_lline_num",
      "meta_sale_document_num"
    ]

  parameter:
    # Total number of iterations. Usually changed in tandem with learning_rate
    # https://lightgbm.readthedocs.io/en/latest/Parameters.html#num_iterations
    num_iterations: 1042
    learning_rate: 0.06
    
    # For CV only, proportion of the training data to hold out for use in 
    # early stopping + the metric to evaluate. See R docs for details:
    # https://lightgbm.readthedocs.io/en/latest/R/reference/lgb.train.html#arguments
    # WARNING: See issue #82 for critical notes about early stopping / CV
    validation_prop: 0.1
    validation_type: "recent"
    validation_metric: "rmse"
    
    # Custom parameters added by the CCAO's lightsnip wrapper package. Setting
    # to TRUE will set max_depth = floor(log2(num_leaves)) + add_to_linked_depth
    # This is to prevent tune_bayes from exploring useless parameter space
    link_max_depth: TRUE
    
    # Maximum number of bins for discretizing continuous features. Lower uses
    # less memory and speeds up training
    max_bin: 512
    
    # During CV, the number of iterations to go without improvement before
    # stopping training
    stop_iter: 40

  hyperparameter:
    # Default set of hyperparameters to use if CV is not enabled. See docs for
    # details: https://lightgbm.readthedocs.io/en/latest/Parameters.html
    default:
      num_leaves: 159
      add_to_linked_depth: 1
      feature_fraction: 0.688
      min_gain_to_split: 5.58
      min_data_in_leaf: 44
      max_cat_threshold: 228
      min_data_per_group: 160
      cat_smooth: 54.52
      cat_l2: 0.11
      lambda_l1: 0.016
      lambda_l2: 2.413
      neighbors: 5
    
    # Range of possible hyperparameter values for tune_bayes to explore
    range:
      num_leaves: [50, 2000]
      add_to_linked_depth: [1, 7]
      feature_fraction: [0.3, 0.8]
      min_gain_to_split: [-4.0, 2.0]
      min_data_in_leaf: [2, 150]
      max_cat_threshold: [20, 250]
      min_data_per_group: [20, 200]
      cat_smooth: [10.0, 100.0]
      cat_l2: [-3, 3]
      lambda_l1: [-3, 3]
      lambda_l2: [-3, 3]
      neighbors: [5, 40]


# Post-Valuation ---------------------------------------------------------------

# Parameters used in the assess stage to finalize the intial model predictions
pv:
  # For nonlivable units, anything below this value gets the same value as the
  # prior year
  nonlivable_threshold: 1000

  # The fixed fair market value of non-livable PINs such as parking spaces,
  # common areas, and storage. These PINs are nearly impossible to value with
  # modeling since they don't really have sales
  nonlivable_fixed_fmv: 30000

  # Cap the proportion of the PIN's total value dedicated to land. This is
  # necessary since sometimes the model provides low predictions relative to the
  # land rates created by Valuations
  land_pct_of_total_cap: 0.5
  
  # Rounding settings to apply to initial predictions. Rounding is done to
  # indicate to property owners that model values are estimates, not exact
  round_break: [1000, 10000]
  round_to_nearest: [1, 10, 100]
  round_type: "ceiling"


# Ratio Study ------------------------------------------------------------------

# Years and assessment stages used to calculate YoY changes in the evaluate
# stage. Typically we want to compare new model values with the finalized values
# (post-appeal) from the last reassessment and the most recent values from the
# prior year
ratio_study:
  far_year: "2020"
  far_stage: "board"
  far_column: "meta_2yr_pri_board_tot"
  near_year: "2022"
  near_stage: "certified"
  near_column: "meta_certified_tot"
  
  # Quantile breakouts to use in the evaluate stage. For example, 3 will split
  # each geography in evaluate into terciles
  num_quantile: [3, 5, 10]


# Export -----------------------------------------------------------------------

# Final run ID(s) chosen for export to Desk Review spreadsheets and iasWorld
# upload
export:
  triad_code: "3"
  run_id: "2023-03-16-keen-tayun"
